%%
%% Copyright (C) 2005 Eric Chassande-Mottin, CNRS (France)
%%
%% This program may be freely copied under the terms of the 
%% GNU General Public License (GPL), version 2, or at your 
%% option any later version.
%%


%% test of dynamic programming, tests series 1

debug_level=0;

printf("\ntest1: \n");
printf("------ \n");

a=[1,0,1,1;
   0,1,2,0;
   2,0,1,1;
   0,0,0,0];
idx_exact=[3 1 1];
s3=pathint(a,idx_exact);

[s1,idx]=dp_bcc(a,2,1,2,1,debug_level);
s2=pathint(a,idx);

printf("matrix is \n");
flipud(a)

printf("true solution is %d %d %d\n",idx_exact);
printf("       result is %d %d %d\n",idx);
printf("at positions: [1 3 5]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test1 failed\n");
else
  printf("test1 passed\n");
end;

printf("\ntest2: \n");
printf("------ \n");

b=[0,0,0,0;
   0,0,0,1;
   0,0,1,0;
   1,1,0,0];
idx_exact=[4 3 1];
s3=pathint(b,idx_exact);

[s1,idx]=dp_bcc(b,2,2,1,1,debug_level);
s2=pathint(b,idx);

printf("matrix is \n");
flipud(b)

printf("true solution is %d %d %d\n",idx_exact);
printf("       result is %d %d %d\n",idx);
printf("at positions: [1 3 5]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test2 failed\n");
else
  printf("test2 passed\n");
end;

printf("\ntest3: \n");
printf("------ \n");

c=[0,0,0,0;
   0,0,0,1;
   1,1,1,0;
   0,0,0,0];
idx_exact=[3 3 2];
s3=pathint(c,idx_exact);

[s1,idx]=dp_bcc(c,2,2,1,1,debug_level);
s2=pathint(c,idx);

printf("matrix is \n");
flipud(c)

printf("true solution is %d %d %d\n",idx_exact);
printf("       result is %d %d %d\n",idx);
printf("at positions: [1 3 5]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test3 failed\n");
else
  printf("test3 passed\n");
end;

printf("\ntest4: \n");
printf("------ \n");

d=[0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,1;
   0,0,1,1,1,1,1,0;
   1,0,0,0,0,1,0,0;
   0,1,0,0,1,0,0,0;
   1,1,1,1,0,0,0,0;
   0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0];

idx_exact=[6 6 5 3 1];
s3=pathint(d,idx_exact);

[s1,idx]=dp_bcc(d,2,2,1,1,debug_level);
s2=pathint(d,idx);

printf("matrix is \n");
flipud(d)

printf("true solution is %d %d %d %d %d\n",idx_exact);
printf("       result is %d %d %d %d %d\n",idx);
printf("at positions: [1 3 5 7 9]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test4 failed\n");
else
  printf("test4 passed\n");
end;

printf("\ntest5: \n");
printf("------ \n");

e=[0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0;
   0,1,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0;
   0,0,0,1,0,0,0,0;
   0,0,0,0,1,1,1,1;
   0,0,0,0,0,0,0,0];

idx_exact=[3 7 7];
s3=pathint(e,idx_exact);

[s1,idx]=dp_bcc(e,4,2,2,2,debug_level);
s2=pathint(e,idx);

printf("matrix is \n");
flipud(e)

printf("true solution is %d %d %d\n",idx_exact);
printf("       result is %d %d %d\n",idx);
printf("at positions: [1 5 9]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test5 failed\n");
else
  printf("test5 passed\n");
end;

printf("\ntest6: \n");
printf("------ \n");

f=[0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0;
   0,1,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0;
   0,0,0,1,0,0,0,0;
   0,0,0,0,1,1,1,1;
   0,0,0,0,0,0,0,0];

idx_exact=[5 7 7];
s3=pathint(f,idx_exact);

[s1,idx]=dp_bcc(f,4,2,2,1,debug_level);
s2=pathint(f,idx);

printf("matrix is \n");
flipud(f)

printf("true solution is %d %d %d\n",idx_exact);
printf("       result is %d %d %d\n",idx);
printf("at positions: [1 5 9]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test6 failed\n");
else
  printf("test6 passed\n");
end;

printf("\ntest7: \n");
printf("------ \n");

g=[0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,1;
   0,0,0,0,0,0,1,0;
   0,0,0,0,0,1,0,0;
   0,0,0,0,1,0,0,0;
   0,0,1,1,0,0,0,0;
   1,1,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0];

idx_exact=[7 5 1];
s3=pathint(g,idx_exact);

[s1,idx]=dp_bcc(g,4,2,2,1,debug_level);
s2=pathint(g,idx);
 
printf("matrix is \n");
flipud(g)

printf("true solution is %d %d %d\n",idx_exact);
printf("       result is %d %d %d\n",idx);
printf("at positions: [1 5 9]\n\n");

printf(" true total is %2.1f\n",s3);
printf("     result is %2.1f\n",s1);
printf("chk pathint is %2.1f\n\n",s2);

if (s1~=s3)|(s1~=s2)
  error("test7 failed\n");
else
  printf("test7 passed\n");
end;
