%%
%% Copyright (C) 2005 Eric Chassande-Mottin, CNRS (France)
%%
%% This program may be freely copied under the terms of the 
%% GNU General Public License (GPL), version 2, or at your 
%% option any later version.
%%

%% make graphics for figure0b

clear

debug=0;

%% -- get the data
load figure0b.mat
w=w.*(w>0);

%% -- make plots
clf;

subplot(1,2,1)
t=(1:N)/fs; T=N/fs;
f=fs*(0:N-1)/(2*N);
imagesc(t,f,w);
colormap(flipud(gray));
axis('xy');
axis([0 T 0 fs/2]);
axis('square');
l1=xlabel('time [s]');
l2=ylabel('frequency [Hz]');
l3=title(['GW chirp in Gaussian noise, SNR=',num2str(snr)]);

if ~is_octave,
  set(gca,'FontSize',12);
  set(l1,'FontSize',12);
  set(l2,'FontSize',12);
  set(l3,'FontSize',12);
end;

subplot(1,2,2);
tm=(1:b:N+1)'/fs;
if is_octave,
  plot(t,fs*ifl,'g-');
  hold on;
  plot(tm,fs*m_cc/2/N,'r--');
  plot([t1 t1]/fs,[0 fs/2],'b:');
  plot([t2 t2]/fs,[0 fs/2],'m:');
  hold off
else
  h1=plot(t,fs*ifl,'g-');
  hold on;
  h2=plot(tm,fs*m_cc/2/N,'r--');
  h3=plot([t1 t1]/fs,[0 fs/2],'b:');
  h4=plot([t2 t2]/fs,[0 fs/2],'m:');
  h5=plot([t(1) t(end)],fs*[fisco fisco],'k-.');
  hold off
end;
axis('square');
axis([0 T 0 fs/2]);
l1=xlabel('time [s]');
l2=ylabel('frequency [Hz]');
l3=title('GW chirp [solid/green] best CC [dashed/red]');

if ~is_octave,
  set(gca,'FontSize',12);
  set(h1,'LineWidth',1.5);
  set(h1,'MarkerSize',2);
  set(h2,'LineWidth',1.5);
  set(h2,'MarkerSize',2);
  set(h3,'LineWidth',1.5);
  set(h3,'MarkerSize',2);
  set(h4,'LineWidth',1.5);
  set(h4,'MarkerSize',2);
  set(h5,'LineWidth',1.5);
  set(h5,'MarkerSize',2);
  set(l1,'FontSize',12);
  set(l2,'FontSize',12);
  set(l3,'FontSize',12);

  if (debug==0)
    print('figure0b.eps','-depsc');
    print('figure0b.png','-dpng');
  end;
end;
