%%
%% Copyright (C) 2005 Eric Chassande-Mottin, CNRS (France)
%%
%% This program may be freely copied under the terms of the 
%% GNU General Public License (GPL), version 2, or at your 
%% option any later version.
%%


%% compute ROC curve for a given detection procedure

function [pfa,pfd,thr,N,n_trial]=figure1_calc(algo_str,snr);

% -- define number of trials
#n_trial=10;
n_trial=1e5;
n_step=n_trial/10;

% -- H0: noise only, compute statistic
eval(sprintf('fprintf("compute pfa for %s: ");',algo_str));
lambda=zeros(n_trial,1);
for icol=1:n_trial
  if rem(icol,n_step)==0,
    printf("* "); fflush(1);
  end;
  x=get_signal1(0);
  eval(sprintf("l=%s (x);",algo_str));
  lambda(icol)=l;
end;
printf("\n");
N=length(x);

% -- define threshold
n_threshold=1000;
thmin=min(lambda);
lshift=0.0;
if (thmin<=0),     # if statistics takes negative value
  lshift=-thmin+1; # we add a constant so that lambda is >0
  lambda+=lshift;  # otherwise logspace fails
  thmin=0.9;
end;
thmax=10*max(lambda);
thr=logspace(log10(thmin),log10(thmax),n_threshold);

% -- compute pfa
pfa=zeros(n_threshold,1);
for icol=1:n_threshold
  pfa(icol)=sum(lambda>thr(icol))/n_trial;
end;

% -- H1: signal + noise, compute statistic
eval(sprintf('fprintf("compute pfd for %s: ");',algo_str));
lambda=zeros(n_trial,1);
for icol=1:n_trial
  if rem(icol,n_step)==0,
    fprintf('* ');fflush(1);
  end;
  x=get_signal1(snr);
  eval(sprintf('lambda(icol)=%s (x);',algo_str));
end;
fprintf('\n');

if (lshift>0),     # add constant accordingly to H_0 if needed
  lambda+=lshift;  
end;

% -- compute pfd
pfd=zeros(n_threshold,1);
for icol=1:n_threshold
  pfd(icol)=sum(lambda>thr(icol))/n_trial;
end;

if (lshift>0),     # correct thresholds to compensate the constant shift
    thr-=lshift;     # if needed
end;

return;
