%%
%% Copyright (C) 2005 Eric Chassande-Mottin, CNRS (France)
%%
%% This program may be freely copied under the terms of the 
%% GNU General Public License (GPL), version 2, or at your 
%% option any later version.
%%

%% this is a demonstration
%% generate a random chirp and search with BCC

clear;

snr=10;

%% -- define signal size
N=1024;
b=32;
Ns1=16;
Ns2=8;
ml=128;
mu=N-ml;
shift_flag=0;

%% -- generate signal
[p,ifl_exact,m_exact]=randchirp(N,b,Ns1,1,Ns2,ml,mu,shift_flag);
p0=rand*2*pi;
s=cos(p+p0);

%% -- generate noise, scale and add
x=randn(N,1);
a=sqrt(2/N)*snr;
x=x+a*s;
%x=s;

%% -- compute TFR
w=dwv(x);
w=w(1:N,:);

%% -- apply BCC
[l,m_cc]=dp_bcc(w,b,Ns1,1,Ns2);

%% -- plot results
t=(1:b:N+1)';
plot(ifl_exact,"b-;chirp;");
hold on;
plot(t,(ml+m_exact)/2/N,"bx")
plot(t,m_cc/2/N,"r-;best CC;");
hold off;
xlabel("time");
ylabel("frequency");
axis([1 N 0 0.5]);