%%
%% Copyright (C) 2005 Eric Chassande-Mottin, CNRS (France)
%%
%% This program may be freely copied under the terms of the 
%% GNU General Public License (GPL), version 2, or at your 
%% option any later version.
%%


%%  generates signal and noise for computing ROC curves

%%    SNR<0 returns only signal
%%    SNR=0 returns only noise
%%    SNR>0 returns signal + noise

function x=get_signal1(snr);

%% -- define signal size
N=256;
fin=96/1024;

%% -- compute noise and signal
x=randn(N,1);
s=real(gwchirp(N,fin));

if (snr>0)
%% -- scale to SNR, SNR^2=N A^2/(2 SIGMA^2)
  a=sqrt(2/N)*snr;
  x=x+a*s;
elseif (snr<0)
  x=s;
end;

return;
