%%
%% Copyright (C) 2005 Eric Chassande-Mottin, CNRS (France)
%%
%% This program may be freely copied under the terms of the 
%% GNU General Public License (GPL), version 2, or at your 
%% option any later version.
%%


%% check randchirp.m

clear;

N=1024;
b=32;
Nr1=16;
step=1;
Nr2=8;
ml=128;
mu=N-ml;
shift_flag=0;

ii=1:b-2;
jj=0:b:N-b;
idx0=ones(length(ii),1)*jj+ii'*ones(1,length(jj));
idx0=idx0(:);
idx1=b-1:b:N-b;

n_trial=100; %% check with n_trial trials

for icol=1:n_trial

  [p,f,m]=randchirp(N,b,Nr1,step,Nr2,ml,mu,shift_flag);
  
  if (min(f)<ml/(2*N))|(max(f)>mu/(2*N))
    printf("upper/lower frequency bounds\n");
    error("test failed\n");
  end;
  
  df=diff(f); dfmax=max(abs(df))*2*N*b;
  if (dfmax>Nr1*step)
    printf("chirp regularity: 1st order\n");
    error("test failed\n");
  end;

  ddf=diff(df); ddf0=max(abs(ddf(idx0)));
  if (ddf0>0)
    printf("chirplet chain\n");
    error("test failed\n");
  end;

  ddfmax=max(abs(ddf(idx1)))*2*N*b;
  if (ddfmax>Nr2*step)
    printf("chirp regularity: 2nd order\n");
    error("test failed\n");
  end;

end;
